
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java多线程--同步与死锁：synchronized；等待与唤醒：wait、notify、notifyAll；生命周期 / iVAN</title>

    <meta name="description" content="Java多线程--同步与死锁：synchronized；等待与唤醒：wait、notify、notifyAll；生命周期 1.问题的引出 class MyThread implements Runnable{ private int ticket = 5 ; // 假设一共有5张票 public void run(){ for(int i=0;i&lt;100;i++){ if(ticket&gt;0){ // 还有票 try{ Thread.sleep(300) ; // 加入延迟 }catch(InterruptedException e){ e.printStackTrace() ; } System.out ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java多线程--同步与死锁：synchronized；等待与唤醒：wait、notify、notifyAll；生命周期</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>1、问题的引出</h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIwOTIyNTkxNDA=.jpg"></p>
<pre>class MyThread implements Runnable{
	private int ticket = 5 ;	// 假设一共有5张票
	public void run(){
		for(int i=0;i&lt;100;i++){
			if(ticket&gt;0){	// 还有票
				try{
					Thread.sleep(300) ;	// 加入延迟
				}catch(InterruptedException e){
					e.printStackTrace() ;
				}
				System.out.println("卖票：ticket = " + ticket-- );
			}
		}
	}
};
public class SyncDemo01{
	public static void main(String args[]){
		MyThread mt = new MyThread() ;	// 定义线程对象
		Thread t1 = new Thread(mt) ;	// 定义Thread对象
		Thread t2 = new Thread(mt) ;	// 定义Thread对象
		Thread t3 = new Thread(mt) ;	// 定义Thread对象
		t1.start() ;
		t2.start() ;
		t3.start() ;
	}
};</pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIwOTI0MTI5Mzc=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIwOTI1MDczNTk=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIwOTI2MDQ3MzQ=.jpg"></p>
<h1>2、同步代码块</h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIwOTI3MzgyOTY=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIwOTI4MDkwOTM=.jpg"></p>
<p>同步的时候，必须指明同步的对象，一般情况下会将当前对象作为同步对象，使用this表示。</p>
<pre>class MyThread implements Runnable{
	private int ticket = 5 ;	// 假设一共有5张票
	public void run(){
		for(int i=0;i&lt;100;i++){
			synchronized(this){	// 要对当前对象进行同步
				if(ticket&gt;0){	// 还有票
					try{
						Thread.sleep(300) ;	// 加入延迟
					}catch(InterruptedException e){
						e.printStackTrace() ;
					}
					System.out.println("卖票：ticket = " + ticket-- );
				}
			}
		}
	}
};
public class SyncDemo02{
	public static void main(String args[]){
		MyThread mt = new MyThread() ;	// 定义线程对象
		Thread t1 = new Thread(mt) ;	// 定义Thread对象
		Thread t2 = new Thread(mt) ;	// 定义Thread对象
		Thread t3 = new Thread(mt) ;	// 定义Thread对象
		t1.start() ;
		t2.start() ;
		t3.start() ;
	}
};</pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIwOTMwMTYwOTM=.jpg"></p>
<h1>3、同步方法</h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIwOTMxMDA3ODE=.jpg"></p>
<pre>class MyThread implements Runnable{
	private int ticket = 5 ;	// 假设一共有5张票
	public void run(){
		for(int i=0;i&lt;100;i++){
			this.sale() ;	// 调用同步方法
		}
	}
	public synchronized void sale(){	// 声明同步方法
		if(ticket&gt;0){	// 还有票
			try{
				Thread.sleep(300) ;	// 加入延迟
			}catch(InterruptedException e){
				e.printStackTrace() ;
			}
			System.out.println("卖票：ticket = " + ticket-- );
		}

	}
};
public class SyncDemo03{
	public static void main(String args[]){
		MyThread mt = new MyThread() ;	// 定义线程对象
		Thread t1 = new Thread(mt) ;	// 定义Thread对象
		Thread t2 = new Thread(mt) ;	// 定义Thread对象
		Thread t3 = new Thread(mt) ;	// 定义Thread对象
		t1.start() ;
		t2.start() ;
		t3.start() ;
	}
};</pre>

<h1>4、死锁</h1>
<p>过多的同步可能导致死锁：死锁表示在程序时，互相等待。</p>
<p>程序模拟：张三向李四要画，用书交换；李四向张三要书，用画交换。</p>
<pre>class Zhangsan{	// 定义张三类
	public void say(){
		System.out.println("张三对李四说：“你给我画，我就把书给你。”") ;
	}
	public void get(){
		System.out.println("张三得到画了。") ;
	}
};
class Lisi{	// 定义李四类
	public void say(){
		System.out.println("李四对张三说：“你给我书，我就把画给你”") ;
	}
	public void get(){
		System.out.println("李四得到书了。") ;
	}
};
public class ThreadDeadLock implements Runnable{
	private static Zhangsan zs = new Zhangsan() ;		// 实例化static型对象
	private static Lisi ls = new Lisi() ;		// 实例化static型对象
	private boolean flag = false ;	// 声明标志位，判断那个先说话
	public void run(){	// 覆写run()方法
		if(flag){
			synchronized(zs){	// 同步张三
				zs.say() ;
				try{
					Thread.sleep(500) ;
				}catch(InterruptedException e){
					e.printStackTrace() ;
				}
				synchronized(ls){
					zs.get() ;
				}
			}
		}else{
			synchronized(ls){
				ls.say() ;
				try{
					Thread.sleep(500) ;
				}catch(InterruptedException e){
					e.printStackTrace() ;
				}
				synchronized(zs){
					ls.get() ;
				}
			}
		}
	}
	public static void main(String args[]){
		ThreadDeadLock t1 = new ThreadDeadLock() ;		// 控制张三
		ThreadDeadLock t2 = new ThreadDeadLock() ;		// 控制李四
		t1.flag = true ;
		t2.flag = false ;
		Thread thA = new Thread(t1) ;
		Thread thB = new Thread(t2) ;
		thA.start() ;
		thB.start() ;
	}
};</pre>
<h1>5、Object类对线程的支持-----------唤醒和等待：notify、notifyAll、wait</h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIxMTA4Mzg2MDk=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIxMTA5MjAwNDY=.jpg"></p>
<p>线程操作经典案例程序：生产者和消费之问题，生产者不断生产，消费者不断取走生产者生产的产品。</p>
<p>加入等待与唤醒：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIxMTExMTc0Njg=.jpg"></p>
<pre>class Info{	// 定义信息类
	private String name = "李兴华";	 // 定义name属性
	private String content = "JAVA讲师"  ;		// 定义content属性
	private boolean flag = false ;	// 设置标志位
	public synchronized void set(String name,String content){
		if(!flag){
			try{
				super.wait() ;
			}catch(InterruptedException e){
				e.printStackTrace() ;
			}
		}
		this.setName(name) ;	// 设置名称
		try{
			Thread.sleep(300) ;
		}catch(InterruptedException e){
			e.printStackTrace() ;
		}
		this.setContent(content) ;	// 设置内容
		flag  = false ;	// 改变标志位，表示可以取走
		super.notify() ;
	}
	public synchronized void get(){
		if(flag){
			try{
				super.wait() ;
			}catch(InterruptedException e){
				e.printStackTrace() ;
			}
		}
		try{
			Thread.sleep(300) ;
		}catch(InterruptedException e){
			e.printStackTrace() ;
		}
		System.out.println(this.getName() +
			" --&gt; " + this.getContent()) ;
		flag  = true ;	// 改变标志位，表示可以生产
		super.notify() ;
	}
	public void setName(String name){
		this.name = name ;
	}
	public void setContent(String content){
		this.content = content ;
	}
	public String getName(){
		return this.name ;
	}
	public String getContent(){
		return this.content ;
	}
};
class Producer implements Runnable{	// 通过Runnable实现多线程
	private Info info = null ;		// 保存Info引用
	public Producer(Info info){
		this.info = info ;
	}
	public void run(){
		boolean flag = false ;	// 定义标记位
		for(int i=0;i&lt;50;i++){
			if(flag){
				this.info.set("李兴华","JAVA讲师") ;	// 设置名称
				flag = false ;
			}else{
				this.info.set("mldn","www.mldnjava.cn") ;	// 设置名称
				flag = true ;
			}
		}
	}
};
class Consumer implements Runnable{
	private Info info = null ;
	public Consumer(Info info){
		this.info = info ;
	}
	public void run(){
		for(int i=0;i&lt;50;i++){
			this.info.get() ;
		}
	}
};
public class ThreadCaseDemo03{
	public static void main(String args[]){
		Info info = new Info();	// 实例化Info对象
		Producer pro = new Producer(info) ;	// 生产者
		Consumer con = new Consumer(info) ;	// 消费者
		new Thread(pro).start() ;
		new Thread(con).start() ;
	}
};</pre>
<h1>6、线程的生命周期</h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIxNTA0MzcwMTU=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzEwMTIxNTA1MTg2ODc=.jpg"></p>
<pre>class MyThread implements Runnable{
	private boolean flag = true ;	// 定义标志位
	public void run(){
		int i = 0 ;
		while(this.flag){
			System.out.println(Thread.currentThread().getName()
				+"运行，i = " + (i++)) ;
		}
	}
	public void stop(){
		this.flag = false ;	// 修改标志位
	}
};
public class StopDemo{
	public static void main(String args[]){
		MyThread my = new MyThread() ;
		Thread t = new Thread(my,"线程") ;	// 建立线程对象
		t.start() ;	// 启动线程
		try{
			Thread.sleep(30) ;
		}catch(Exception e){

		}
		my.stop() ;	// 修改标志位，停止运行
	}
};</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-21 22:42:54</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java多线程--同步与死锁：synchronized；等待与唤醒：wait、notify、notifyAll；生命周期的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMl5j8p.html" rel="bookmark">Java多线程同步问题的探究（一、线程的先来后到）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				众所周知,在Java多线程编程中,一个非常重要的方面就是线程的同步问题. 关于线程的同步,一般有以下解决方法: 1. 在需要同步的方法的方法签名中加入synchronized关键字. 2. 使用synchronized块对需要进行同步的代码段进行同步. 3. 使用JDK 5中提供的java.util.concurrent.lock包中的Lock对象. 另外,为了解决多个线程对同一变量进行访问时可能发生的安全性问题,我们不仅可以采用同步机制,更可以通过JDK 1.2中加入的 ThreadLocal			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mlg37Lb.html" rel="bookmark">java多线程-同步块实例讲解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java多线程-同步块 Java 同步块(synchronized block)用来标记方法或者代码块是同步的.Java 同步块用来避免竞争.本文介绍以下内容: Java 同步关键字(synchronzied) 实例方法同步 静态方法同步 实例方法中同步块 静态方法中同步块 Java 同步示例 Java 同步关键字(synchronized) Java 中的同步块用 synchronized 标记.同步块在 Java 中是同步在某个对象上.所有同步在一个对象上的同步块在同时只能被一个线程进入并执			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b32lrJz.html" rel="bookmark">java多线程同步问题，小弟百撕不得其解，特来求助！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java多线程同步问题,小弟百撕不得其解,特来求助! 多线程共享同一资源,同一张票卖出了多张!同步方法,同步代码块都没用. 问题:编写三各类Ticket.SealWindow.TicketSealCenter分别代表票信息.售票窗口.售票中心.售票中心分配一定数量的票,由若干个售票窗口进行出售,利用你所学的线程知识来模拟此售票过程. public class ThreadDemo { public static void main(String[] args) { Thread t1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7xx5qb.html" rel="bookmark">java多线程同步的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java多线程同步的问题 小测试,如何实现变量ticket的同步 private int ticket = 100; public void run() { while(ticket &gt; 0 ) { System.out.println(ticket+&quot; is saled by &quot;+ Thread.currentThread().getName()); ticket--; try { Thread.sleep(200); } catch (InterruptedExce			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQkd4p.html" rel="bookmark">ava 同步-Java 多线程同步工具 CyclicBarrier</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Java 多线程同步工具 CyclicBarrier Java中使用CyclicBarrier控制多个线程在执行完后,才执行后续操作,请大家帮我分析下,项目两个代码中为什么执行结果不一样: 代码1. public class CyclicBarrierTest2 { public static void main(String[] args) throws InterruptedException, BrokenBarrierException { final CyclicBarrie			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdyyG3z.html" rel="bookmark">java多线程编程之使用Synchronized关键字同步类方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: public synchronized void run(){     } 从上面的代码可以看出,只要在void和public之间加上synchronized关键字,就可以使run方法同步,也就是说,对于同一个Java类的对象实例,run方法同时只能被一个线程调用,并当前的run执行完后,才能被其他的线程调用.即使当前线程执行到了run方法中的yield方法,也只是暂停了一下.由于其他线程无法执行run方法,因此,最终还是会由当前的线程来继续执行.先看看下面的代码:sych			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvVLNM.html" rel="bookmark">Java多线程同步问题的探究&lpar;三、Lock来了，大家都让开【1&period;认识重入锁】&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一节中,我们已经了解了Java多线程编程中常用的关键字synchronized,以及与之相关的对象锁机制.这一节中,让我们一起来认 识JDK 5中新引入的并发框架中的锁机制. 我想很多购买了&lt;Java程序员面试宝典&gt;之类图书的朋友一定对下面这个面试题感到非常熟悉: 问:请对比synchronized与java.util.concurrent.locks.Lock 的异同. 答案:主要相同点:Lock能完成synchronized所实现的所有功能 主要不同点:Lock有比synchroniz			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xpnlZ2b.html" rel="bookmark">Java多线程同步问题的探究（二、给我一把锁，我能创造一个规矩）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇中,我们讲到了多线程是如何处理共享资源的,以及保证他们对资源进行互斥访问所依赖的重要机制:对象锁. 本篇中,我们来看一看传统的同步实现方式以及这背后的原理. 很多人都知道,在Java多线程编程中,有一个重要的关键字,synchronized.但是很多人看到这个东西会感到困惑:&quot;都说同步机制是 通过对象锁来实现的,但是这么一个关键字,我也看不出来Java程序锁住了哪个对象阿?&quot; 没错,我一开始也是对这个问题感到困惑和不解.不过还好,我们有下面的这个例程: 1 public cla			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxPv9PM.html" rel="bookmark">Java多线程同步中的两个特殊类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java语言内置了synchronized关键字用于对多线程进行同步,大大方便了Java中多线程程序的编写.但是仅仅使用synchronized关键字还不能满足对多线程进行同步的所有需要.大家知道,synchronized仅仅能够对方法或者代码块进行同步,如果我们一个应用需要跨越多个方法进行同步,synchroinzed就不能胜任了.在C++中有很多同步机制,比如信号量.互斥体.临届区等.在Java中也可以在synchronized语言特性的基础上,在更高层次构建这样的同步工具,以方便我们的使用			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bok86b.html" rel="bookmark" class="title">看实例学VFP：删除数据表中的记录</a>
					<div>
						本例对看实例学VFP:对数据表中记录进行修改一文的实例进行了一点改进,增加了&quot;撤消&quot;功能.程序运行时如下图: 在组合框中选择要查找的字段,在文本框中输入查找内容后单击右侧的&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yVAoz.html" rel="bookmark" class="title">Oracle中ALTER USER的REPLACE语句</a>
					<div>
						ALTER USER语句有一个可选的REPLACE语句,用来在启动密码验证函数后,输入原始密码. 默认情况下,用户修改自己的密码不需要提供当前密码: SQL&gt; create user test  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2WnZp.html" rel="bookmark" class="title">php echo 函数</a>
					<div>
						 echo 在php相当重要的,虽然看上去它简单语法也简单,但是echo函数在程序中会常常被用到,它的作用是用于输,变量,字符串,常量,html等; 正如你看到在过去的教训, PHP的命令echo是一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGYY7p.html" rel="bookmark" class="title">Spring Boot 整合 Mybatis Annotation 注解的完整 Web 案例</a>
					<div>
						摘要: 原创出处 www.bysocket.com 「泥瓦匠BYSocket 」欢迎转载,保留摘要,谢谢! 『 公司需要人.产品.业务和方向,方向又要人.产品.业务和方向,方向- 循环』 本文提纲 一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrvlwM.html" rel="bookmark" class="title">c&plus;&plus;-C&plus;&plus;程序编译出错，帮忙修改，可以的话，把修改后的完整程序发上来</a>
					<div>
						问题描述 C++程序编译出错,帮忙修改,可以的话,把修改后的完整程序发上来 #include #include #include #define max 5 typedef struct{ char  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZ9mkb.html" rel="bookmark" class="title">Solr DocValues详解</a>
					<div>
						  什么是docValues? docValues是一种记录doc字段值的一种形式,在例如在结果排序和统计Facet查询时,需要通过docid取字段值的场景下是非常高效的. 为什么要使用docValu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamAqnb.html" rel="bookmark" class="title">日本人为什么不创业？</a>
					<div>
						上周在日本的时候,随一位友人去拜访他在筑波大学留学时的老师.在行前,为了遵守日本&quot;守时&quot;的规矩,他只告诉我这位老师是那种&quot;一小时挣几万&quot;的厉害角色,我们不能迟到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrqeGM.html" rel="bookmark" class="title">电脑不识别U盘启动盘了怎么办怎么恢复</a>
					<div>
						现在好多人都直接用U盘当做电脑启动盘.往往由于在使用U盘的过程中,不小心被病毒或自己使用时不规范操作将自己的心爱之物很快出现这样或那样的问题.这篇文章主要解决U盘等可移动存储设备不能识别的问题. 首先 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdE1v6z.html" rel="bookmark" class="title">Android--Handler的使用方法：在子线程中更新界面</a>
					<div>
						本文主要介绍Android的Handler的使用方法.Handler可以发送Messsage和Runnable对象到与其相关联的线程的消息队列.每个Handler对象与创建它的线程相关联,并且每个Ha ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYqKOp.html" rel="bookmark" class="title">关于JSP构建大型建材商务网站的框架选型问题</a>
					<div>
						问题描述 请问一下,如果我通过想以JAVA为开发语言实现大型建材商务网站的话,需要什么样的框架,如jsp+servlet+javabean还是struts2.x+extjs等,系统肯定是分布式的,采用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRnD8b.html" rel="bookmark" class="title">阿里云DTS实施小记</a>
					<div>
						       最近在XX客户现场进行了一次RDS数据库灾备实施,使用的是阿里云的数据传输服务.这里先简单介绍一下,数据传输(Data Transmission)是阿里云提供的一种支持RDBMS(关系型 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZkWLM.html" rel="bookmark" class="title">c&plus;&plus; 编程问题-设计一个C&plus;&plus;编程 写代码</a>
					<div>
						问题描述 设计一个C++编程 写代码 请问如何用C++编程运用调用方式 输出200以内所有的素数 及其个数?? 解决方案 #includeint isprime(int n){ if(n&lt;2)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLqjdp.html" rel="bookmark" class="title">Java Algebra System 2&period;4&period;3938发布 多线程的计算机代数系统</a>
					<div>
						Java Algebra System(JAS)是一款面向对象.类型安全和多线程的计算机代数系统.JAS提供了一个精心设计的软件库,在Java编程语言实现了使用泛型类型进行代数运算.该系统用于任何其他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAxWDp.html" rel="bookmark" class="title">MySQL使用query cache缓存简单使用教程</a>
					<div>
						1. query cache的key是sql字符串,并且要求精确匹配:大小写不一样或者多了一个空格,都会导致cache miss 2. query cache直接把用户输入的原始sql作为key, 不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKZ3Lb.html" rel="bookmark" class="title">Linux下常用的shell命令记录</a>
					<div>
						本文章记录我在linux系统下常用或有用的系统级命令,包括软硬件查看.修改命令,有CPU.内存.硬盘.网络.系统管理等命令.但本文不打算介绍生僻命令,也不介绍各个linux发行版下的特有命令,且以后会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7lB5M.html" rel="bookmark" class="title">抢票插件依然能用 但不是&OpenCurlyDoubleQuote;神器&rdquo;</a>
					<div>
						昨天,央视新闻官方微博说,金山.360.遨游等多家浏览器公司否认接到工信部叫停http://www.aliyun.com/zixun/aggregation/12145.html&quot;&gt;抢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKrQdb.html" rel="bookmark" class="title">eclipse创建模拟器后emulator control 是灰色。</a>
					<div>
						问题描述 eclipse创建模拟器后emulator control 是灰色. eclipse创建模拟器后emulator control 是灰色,无法进行来电和短信的测试.各种方法都试了还是不行,请 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkeP1M.html" rel="bookmark" class="title">string-帮忙解读一下这段代码</a>
					<div>
						问题描述 帮忙解读一下这段代码 private static String encodeStr = &quot;$#TGDF*FAA&amp;21we@VGXD532w23413!&quot;; pu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRB00p.html" rel="bookmark" class="title">安卓开发-这个安卓界面要怎么做啊 求大神帮忙</a>
					<div>
						问题描述 这个安卓界面要怎么做啊 求大神帮忙 开发-这个安卓界面要怎么做啊 求大神帮忙-安卓开发大神&quot;&gt; 就是这样一个界面 解决方案 兄弟,你的图片看不到呀---					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW72wrM.html" rel="bookmark" class="title">蓝汛首鸣数据中心今个儿要一鸣惊人</a>
					<div>
						总建筑面积约8万平方米.能够容纳约1.5万个机柜位的蓝汛首鸣数据中心即将启用.以此为分水岭,以前一直默默前行的蓝汛旗下的数据中心业务,逐渐显露出其&quot;高大上&quot;的特质. 有舍才有得 融 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnm39p.html" rel="bookmark" class="title">GO语言中的常量&lowbar;Golang</a>
					<div>
						常量是程序中最基础的元素,在定义之后就不能再重新赋值了.Go语言中的常量类型有布尔常量.整数常量.浮点数常量. 字符常量.字符串常量和复数常量 . 布尔常量 复制代码 代码如下: const x =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDky4vp.html" rel="bookmark" class="title">Java的JSON格式转换库GSON的初步使用笔记&lowbar;java</a>
					<div>
						现在已经有一些能将Java对象转换成JSON的开源项目了.但是大多数项目都要求你在类文件中加入Java注解,而当你无法改动源代码的时候这是无法做到的.并且它们也不支持Java泛型.但是Gson却将这两 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1ZEab.html" rel="bookmark" class="title">JQuery对表单元素的基本操作使用总结&lowbar;jquery</a>
					<div>
						select下拉列表onChange事件之JQuery实现: JQuery: $(document).ready(function () { $(&quot;#selectMenu&quot;).bi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ28o6z.html" rel="bookmark" class="title">动态表单中的值转换问题（Map）</a>
					<div>
						问题描述 publicStringadd()throwsException{Documentdocument=newDocument();document.setTitle(docInfo.getTi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wdmRz.html" rel="bookmark" class="title">卢国馥：六招教会你筛选关键词</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 SEOER最只要的就是要选对我们的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQW8lrp.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;有收录无排名&rdquo;实况分析</a>
					<div>
						摘要: 网站收录成千上万为的是什么,还不是祈盼获得较高排名后得到更多的流量吗?但一些网站收录纵然过数万,流量也不会很高,这是什么原因造就呢?今天二进制便对网站有收录无排名现 网站收录成千上万为的是什么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4l0jb.html" rel="bookmark" class="title">PostgreSQL on ECS 横向版本TPCB性能测试</a>
					<div>
						本文对比的是PostgreSQL 9.4, 9.5, 9.6, 以及某基于9.4的国产数据库在ECS上的性能. 硬件环境和搭配 Intel(R) Xeon(R) CPU E5-2680 v3 @ 2. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6qvDob.html" rel="bookmark" class="title">外媒评10款可定制科技礼品：iPod Shuffle上榜</a>
					<div>
						国外媒体周日评出了10款17813.html&quot;&gt;可定制的商业礼品,http://www.aliyun.com/zixun/aggregation/11683.html&quot;&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqOBBaz.html" rel="bookmark" class="title">《深入理解Hadoop（原书第2版）》&mdash;&mdash;第1章 为什么会有大数据   1&period;1 什么是大数据</a>
					<div>
						第1章 为什么会有大数据 随着近20多年来计算技术的不断革新,企业积累了大量数据.数字传感器的进步使得通信系统越来越广泛的使用,尤其是移动平台和移动终端的飞速增长:系统运行产生的大量日志以及越来越多的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEd7o3z.html" rel="bookmark" class="title">TD手机门槛拉至700元以下</a>
					<div>
						本报讯(记者古晓宇)移动千元TD手机战略中的产品终于亮相.昨天,联想移动正式推出了主打低端定位的TD手机TD30t,这款产品也将TD手机入门价格拉到了700元以下. 去年移动启动了千元TD手机研发战略 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
